From c1ac8b4b16b365bd5a3b892d5d5def40180fb2ee Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Dec 11 2017 16:32:36 +0000
Subject: [PATCH 32/51] check filters


---

diff --git a/src/_fedmod/modulemd_linter.py b/src/_fedmod/modulemd_linter.py
index eceb9a5..5842f9b 100644
--- a/src/_fedmod/modulemd_linter.py
+++ b/src/_fedmod/modulemd_linter.py
@@ -523,3 +523,55 @@ class ModuleMDLinter(object):
         """Every module SHOULD define its public API."""
         for block in self.mmd['api'].values():
             self.check_is_scalar(*block)
+
+    @error
+    @guidelines_link('#Module_filters')
+    @detail("The 'filter' block must be a dictionary (key/value).")
+    def lint_filter_dict(self):
+        """Module filters define lists of components or other content that
+        should not be part of the resulting, composed module deliverable."""
+        if 'filter' in self.mmd:
+            self.check_is_dict(self.mmd['filter'])
+
+    @warning
+    @guidelines_link('#Module_filters')
+    @detail("The 'filter' block should only have the 'rpms' key.")
+    @prerequisite('filter_dict')
+    def lint_filter_rpms(self):
+        """Module filters define lists of components or other content that
+        should not be part of the resulting, composed module deliverable.
+        Currently the only supported type of filter are binary RPM packages."""
+        if 'filter' in self.mmd:
+            self.check(set(self.mmd['filter']) == {'rpms'})
+
+    @error
+    @guidelines_link('#Module_filters')
+    @detail("All 'filter' blocks must be lists.")
+    @prerequisite('filter_dict')
+    def lint_filter_blocks_are_lists(self):
+        """Module filters define lists of components or other content that
+        should not be part of the resulting, composed module deliverable."""
+        if 'filter' in self.mmd:
+            self.check_is_list(*self.mmd['filter'].values())
+
+    @warning
+    @guidelines_link('#Module_filters')
+    @detail("The list of filtered RPM packages is empty.")
+    @prerequisite('filter_blocks_are_lists')
+    def lint_filter_rpms_empty(self):
+        """Module filters define lists of components or other content that
+        should not be part of the resulting, composed module deliverable.
+        Currently the only supported type of filter are binary RPM packages."""
+        if 'filter' in self.mmd and 'rpms' in self.mmd['filter']:
+            self.check(len(self.mmd['filter']['rpms']) > 0)
+
+    @error
+    @guidelines_link('#Module_filter')
+    @detail("Every 'filter' block must be a list of scalar items.")
+    @prerequisite('filter_blocks_are_lists')
+    def lint_filter_blocks_items_are_scalar(self):
+        """Module filters define lists of components or other content that
+        should not be part of the resulting, composed module deliverable."""
+        if 'filter' in self.mmd:
+            for block in self.mmd['filter'].values():
+                self.check_is_scalar(*block)

